/*
   This is a demonstration implementation of the customer thread.
   You do not need to modify the contents of this file.

   This implementation does not do any synchronization between the
   customer threads. Each customer thread starts itself in the
   entry state (for 5 seconds), then it enters the dining state
   (for a random amount of time determined by the thread parameter),
   and finally the thread goes into the exit state (for 5 seconds).
*/



// Customer threads move from the entry state to the dining state
// to the exit state and then the thread exits.
void* customer(void* threadParam)
{
   int i;

   // find an empty slot in the array of customers
   i = 0;
   while (customers[i]) i++;
   // put this customer in that slot
   customers[i] = (customer_t*)threadParam;

   Sleep(5000);  // sleep for five seconds in the entry state


   ////// Protocol to enter the dining state.

       // no protocol in this example

   // put this customer in the dining state
   customers[i]->state = 1;

   while(customers[i]->time)
   {
      Sleep(1000);  // sleep one second in the dining state
      customers[i]->time -= 1;  // count down the seconds
   }


   ////// Protocol to leave the dining state.

       // no protocol in this example

   // put this customer in the exit state
   customers[i]->state = 2;

   Sleep(5000);  // sleep five seconds in the exit state

   // free up the customer_t struct
   free( customers[i] );
   customers[i] = NULL;

   ExitThread(0);

   return 0;
}//customer()
