/*
   This file should implement the customer protocol that solves the
   "sushi problem". The dining room is bounded, and once the dining
   room reaches capacity, no other customers are let in until after
   the dining area empties out.

   You need to implement this protocol!
*/

#define ROOM_CAPACITY 5



// Customer threads move from the waiting state to the dining state
// to the exit state and then the thread exits.
void* customer(void* threadParam)
{
   int i;

   // find an empty slot in the array of customers
   i = 0;
   while (customers[i]) i++;
   // put this customer in that slot
   customers[i] = (customer_t*)threadParam;

   Sleep(1000);  // sleep (at least) one second in the entry state


   ////// Protocol to enter the dining state.

       // Your protocol goes here.

   // put this customer in the dining state
   customers[i]->state = 1;

   while(customers[i]->time)
   {
      Sleep(1000);  // sleep one second in the dining state
      customers[i]->time -= 1;  // count down the seconds
   }


   ////// Protocol to leave the dining state.

       // Your protocol goes here.

   // put this customer in the exit state
   customers[i]->state = 2;

   Sleep(5000);  // sleep five seconds in the exit state

   // free up the customer_t struct
   free( customers[i] );
   customers[i] = NULL;

   ExitThread(0);

   return 0;
}//customer()
